/*
         _____          ___   __
        |  __ \        | \ \ / /
        | |__) |___  __| |\ V / 
        |  _  // _ \/ _` | > <  
        | | \ \  __/ (_| |/ . \ 
        |_|  \_\___|\__,_/_/ \_\

        A Win32 Game Programming
               Library
                 by
           Dominique Biesmans
     (c) 1998 - all rights reserved
see readme.1st for copyright information

*/

#include "redx.h"

BOOL DXBitmap_Lock(DX_BITMAP *pdxbBitmap)
{
    DX_CONTEXT *pdxcContext;
    pdxcContext = pdxbBitmap->pdxcContext;

    memset(&(pdxbBitmap->ddsd),0,sizeof(DDSURFACEDESC));
    pdxbBitmap->ddsd.dwSize = sizeof(DDSURFACEDESC);

    pdxcContext->hLastResult=IDirectDrawSurface_Lock(pdxbBitmap->lpDDSBack,NULL, &(pdxbBitmap->ddsd), DDLOCK_WAIT, NULL);
    if (FAILED(pdxcContext->hLastResult))
        RETURN_DDE_FALSE

    return TRUE;
}

BOOL DXBitmap_Unlock(DX_BITMAP *pdxbBitmap)
{
    DX_CONTEXT *pdxcContext;
    pdxcContext = pdxbBitmap->pdxcContext;

    IDirectDrawSurface_Unlock(pdxbBitmap->lpDDSBack,&(pdxbBitmap->ddsd));
    if (FAILED(pdxcContext->hLastResult))
        RETURN_DDE_FALSE

    return TRUE;
}

void DXBitmap_PutPixel(DX_BITMAP *pdxbBitmap, DWORD dwX, DWORD dwY, DWORD dwColor)
{
    DWORD dwBytes = pdxbBitmap->pdxcContext->dwDepth/8; /* number of bytes for 1 pixel */
    LPBYTE lpSurface = (BYTE *)pdxbBitmap->ddsd.lpSurface; /* pointer to the surface */
    lpSurface += pdxbBitmap->ddsd.lPitch*dwY+(dwX*dwBytes);
    switch (dwBytes)
    {
    case 1:
        (*((BYTE *)lpSurface))=(BYTE)dwColor; /* 8 bit */
        break;
    case 2:
        (*((WORD *)lpSurface))=(WORD)dwColor; /* 16 bit */
        break;
    case 3:
        (*((BYTE *)lpSurface))=(BYTE)((dwColor&0xFF0000)>>16);
        (*((WORD *)(lpSurface+1)))=(WORD)(dwColor); /* 24 bit */
        break;
    case 4:
        (*((DWORD *)lpSurface))=(DWORD)dwColor; /* 32 bit */
        break;
    default:
        break;
    }
}
