/*
         _____          ___   __
        |  __ \        | \ \ / /
        | |__) |___  __| |\ V / 
        |  _  // _ \/ _` | > <  
        | | \ \  __/ (_| |/ . \ 
        |_|  \_\___|\__,_/_/ \_\

        A Win32 Game Programming
               Library
                 by
           Dominique Biesmans
     (c) 1998 - all rights reserved
see readme.1st for copyright information

*/

#include "redx.h"

BOOL DX_InitTimer(DX_CONTEXT *pdxcContext, DWORD dwRes)
{
    TIMECAPS tc;

    if (timeGetDevCaps(&tc, sizeof(TIMECAPS)) != TIMERR_NOERROR) 
    {
        return FALSE;
    }

    pdxcContext->uiTimerRes = min(max(tc.wPeriodMin, dwRes), tc.wPeriodMax);
    timeBeginPeriod(pdxcContext->uiTimerRes);
    return TRUE;
}

UINT DX_SetTimer(DX_CONTEXT *pdxcContext, UINT uiDelay, LPTIMECALLBACK lpTimeProc)
{
    return (UINT)timeSetEvent(uiDelay, pdxcContext->uiTimerRes, lpTimeProc, (DWORD)pdxcContext, TIME_PERIODIC);
}

void DX_KillTimer(DX_CONTEXT *pdxcContext, UINT uiTimerId)
{
    /* DX_CONTEXT *pdxcContext is not need here, it's just there for */
    /* keep the API coherent */
    timeKillEvent(uiTimerId);
}

DWORD DX_GetFrameTicks(DX_CONTEXT *pdxcContext)
{
    DWORD dwCount, dwDiff;
    dwCount = GetTickCount();
    dwDiff = dwCount-pdxcContext->dwTicks;
    pdxcContext->dwTicks = dwCount;
    return dwDiff;
}

